@echo off
rem  InstallLatestCygwinSnapshot.bat
rem
rem  Cygwin snapshot auto-installer
rem
rem  Copyright (C) 2005 Gary R. Van Sickle <g.r.vansickle@att.net>
rem
rem  A combined bat/perl script to automatically install the latest snapshot.
rem  Requires Cygwin perl and wget on your Windows path (i.e available outside Cygwin).
rem
rem  This program is free software; you can redistribute it and/or modify
rem  it under the terms of the GNU General Public License as published by
rem  the Free Software Foundation; either version 2 of the License, or
rem  (at your option) any later version.
rem
rem  This program is distributed in the hope that it will be useful,
rem  but WITHOUT ANY WARRANTY; without even the implied warranty of
rem  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
rem  GNU General Public License for more details.
rem
rem  You should have received a copy of the GNU General Public License
rem  along with this program; if not, write to the Free Software
rem  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.


rem Run the perl script part, which is at the end.
perl -x -- %0

if ERRORLEVEL 1 goto :error1

rem  Replace cygwin1.dll
cd c:\unix\bin
del cygwin1.dll
ren deleteme.dll cygwin1.dll
echo Done.
pause
exit

:error1
echo Error.
pause
exit 1

rem -------------------- PERL STARTS HERE -----------------
#!/bin/perl
# My sweet LORD perl is cool!

use File::Temp qw/ tempfile tempdir /;

# Get the snapshots page
print "Getting list of snapshots...\n";
$page = `wget -O- http://www.cygwin.com/snapshots/ 2>/dev/null`;

if ($?)
{
	die "Couldn't get list of snapshots";
}

# Parse the URLs out of it.
(@base) = ($page =~ m|(http.*cygwin-inst.*bz2)|gm);

# Sort them by date, newest to oldest.
@base = sort {$b cmp $a} @base;

# Get the newest one.
$URL = @base[0];
$URL =~ s!//cygwin!//www.cygwin!;
($BASENAME) = (@base[0] =~ m!([^/]*bz2$)!);

print "Latest snapshot is ", $BASENAME, "\n";

# Download the file
print "Downloading ", $URL, "...\n";
system("wget -c -q -nd --directory-prefix=/. $URL") == 0;
#	or die "Couldn't download file";

# Create a temp dir for extracting cygwin1.dll
$tempdir = tempdir( CLEANUP => 1);

# Extract as much as we can (i.e. hopefully everything except cygwin1.dll)
# Extract *only* the cygwin1.dll, to a different name in /bin, and we'll move
# it to its final resting place back in cmd.exe.
print "Extracting...\n";
system("cd / &&
	tar -xjf $BASENAME --exclude=usr/bin/cygwin1.dll &&
	cp $BASENAME $tempdir/$BASENAME &&
	cd $tempdir &&
	tar -xjf $BASENAME usr/bin/cygwin1.dll &&
	cp usr/bin/cygwin1.dll /bin/deleteme.dll") == 0
	or die "Extraction failed";

